## serd 0.24.0~dfsg0

=== wscript ===
#!/usr/bin/env python
import glob
import os
import shutil
import subprocess
import waflib.Logs as Logs
import waflib.Options as Options
import waflib.extras.autowaf as autowaf

# Library and package version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
SERD_VERSION       = '0.24.0'
SERD_MAJOR_VERSION = '0'

# Mandatory waf variables
APPNAME = 'serd'        # Package name for waf dist
VERSION = SERD_VERSION  # Package version for waf dist
top     = '.'           # Source directory
out     = 'build'       # Build directory

def options(opt):
    opt.load('compiler_c')
    autowaf.set_options(opt, test=True)
    opt.add_option('--no-utils', action='store_true', dest='no_utils',
                   help='Do not build command line utilities')
    opt.add_option('--stack-check', action='store_true', dest='stack_check',
                   help='Include runtime stack sanity checks')
    opt.add_option('--static', action='store_true', dest='static',
                   help='Build static library')
    opt.add_option('--no-shared', action='store_true', dest='no_shared',
                   help='Do not build shared library')
    opt.add_option('--static-progs', action='store_true', dest='static_progs',
                   help='Build programs as static binaries')
    opt.add_option('--largefile', action='store_true', dest='largefile',
                   help='Build with large file support on 32-bit systems')
    opt.add_option('--no-posix', action='store_true', dest='no_posix',
                   help='Do not use posix_memalign, posix_fadvise, and fileno, even if present')

def configure(conf):
    conf.load('compiler_c')
    autowaf.configure(conf)
    autowaf.display_header('Serd Configuration')
    autowaf.set_c99_mode(conf)

    conf.env.BUILD_UTILS  = not Options.options.no_utils
    conf.env.BUILD_SHARED = not Options.options.no_shared
    conf.env.STATIC_PROGS = Options.options.static_progs
    conf.env.BUILD_STATIC = (Options.options.static or
                             Options.options.static_progs)

    if not conf.env.BUILD_SHARED and not conf.env.BUILD_STATIC:
        conf.fatal('Neither a shared nor a static build requested')

    if Options.options.stack_check:
        autowaf.define(conf, 'SERD_STACK_CHECK', SERD_VERSION)

    if Options.options.largefile:
        conf.env.append_unique('DEFINES', ['_FILE_OFFSET_BITS=64'])

    if not Options.options.no_posix:
        conf.check(function_name = 'posix_memalign',
                   header_name   = 'stdlib.h',
                   define_name   = 'HAVE_POSIX_MEMALIGN',
                   defines       = ['_POSIX_C_SOURCE=200809L'],
                   mandatory     = False)

        conf.check(function_name = 'posix_fadvise',
                   header_name   = 'fcntl.h',
                   define_name   = 'HAVE_POSIX_FADVISE',
                   defines       = ['_POSIX_C_SOURCE=200809L'],
                   mandatory     = False)

        conf.check(function_name = 'fileno',
                   header_name   = 'stdio.h',
                   define_name   = 'HAVE_FILENO',
                   defines       = ['_POSIX_C_SOURCE=200809L'],
                   mandatory     = False)

    autowaf.define(conf, 'SERD_VERSION', SERD_VERSION)
    autowaf.set_lib_env(conf, 'serd', SERD_VERSION)
    conf.write_config_header('serd_config.h', remove=False)

    autowaf.display_msg(conf, 'Utilities', bool(conf.env.BUILD_UTILS))
    autowaf.display_msg(conf, 'Unit tests', bool(conf.env.BUILD_TESTS))
    print('')

lib_source = [
    'src/env.c',
    'src/node.c',
    'src/reader.c',
    'src/string.c',
    'src/uri.c',
    'src/writer.c',
]

def build(bld):
    # C Headers
    includedir = '${INCLUDEDIR}/serd-%s/serd' % SERD_MAJOR_VERSION
    bld.install_files(includedir, bld.path.ant_glob('serd/*.h'))

    # Pkgconfig file
    autowaf.build_pc(bld, 'SERD', SERD_VERSION, SERD_MAJOR_VERSION, [],
                     {'SERD_MAJOR_VERSION' : SERD_MAJOR_VERSION})

    libflags = ['-fvisibility=hidden']
    libs     = ['m']
    defines  = []
    if bld.env.MSVC_COMPILER:
        libflags = []
        libs     = []
        defines  = ['snprintf=_snprintf']

    # Shared Library
    if bld.env.BUILD_SHARED:
        bld(features        = 'c cshlib',
            export_includes = ['.'],
            source          = lib_source,
            includes        = ['.', './src'],
            lib             = libs,
            name            = 'libserd',
            target          = 'serd-%s' % SERD_MAJOR_VERSION,
            vnum            = SERD_VERSION,
            install_path    = '${LIBDIR}',
            defines         = defines + ['SERD_SHARED', 'SERD_INTERNAL'],
            cflags          = libflags)

    # Static library
    if bld.env.BUILD_STATIC:
        bld(features        = 'c cstlib',
            export_includes = ['.'],
            source          = lib_source,
            includes        = ['.', './src'],
            lib             = libs,
            name            = 'libserd_static',
            target          = 'serd-%s' % SERD_MAJOR_VERSION,
            vnum            = SERD_VERSION,
            install_path    = '${LIBDIR}',
            defines         = defines + ['SERD_INTERNAL'])

    if bld.env.BUILD_TESTS:
        test_libs       = libs
        test_cflags     = ['']
        test_linkflags  = ['']
        if not bld.env.NO_COVERAGE:
            test_cflags    += ['--coverage']
            test_linkflags += ['--coverage']

        # Profiled static library for test coverage
        bld(features     = 'c cstlib',
            source       = lib_source,
            includes     = ['.', './src'],
            lib          = test_libs,
            name         = 'libserd_profiled',
            target       = 'serd_profiled',
            install_path = '',
            defines      = defines + ['SERD_INTERNAL'],
            cflags       = test_cflags,
            linkflags    = test_linkflags)

        # Static profiled serdi for tests
        bld(features     = 'c cprogram',
            source       = 'src/serdi.c',
            includes     = ['.', './src'],
            use          = 'libserd_profiled',
            lib          = test_libs,
            target       = 'serdi_static',
            install_path = '',
            defines      = defines,
            cflags       = test_cflags,
            linkflags    = test_linkflags)

        # Unit test program
        bld(features     = 'c cprogram',
            source       = 'tests/serd_test.c',
            includes     = ['.', './src'],
            use          = 'libserd_profiled',
            lib          = test_libs,
            target       = 'serd_test',
            install_path = '',
            defines      = defines,
            cflags       = test_cflags,
            linkflags    = test_linkflags)

    # Utilities
    if bld.env.BUILD_UTILS:
        obj = bld(features     = 'c cprogram',
                  source       = 'src/serdi.c',
                  target       = 'serdi',
                  includes     = ['.', './src'],
                  use          = 'libserd',
                  lib          = libs,
                  install_path = '${BINDIR}')
        if not bld.env.BUILD_SHARED or bld.env.STATIC_PROGS:
            obj.use = 'libserd_static'
        if bld.env.STATIC_PROGS:
            obj.env.SHLIB_MARKER = obj.env.STLIB_MARKER
            obj.linkflags        = ['-static']

    # Documentation
    autowaf.build_dox(bld, 'SERD', SERD_VERSION, top, out)

    # Man page
    bld.install_files('${MANDIR}/man1', 'doc/serdi.1')

    bld.add_post_fun(autowaf.run_ldconfig)
    if bld.env.DOCS:
        bld.add_post_fun(fix_docs)

def lint(ctx):
    subprocess.call('cpplint.py --filter=+whitespace/comments,-whitespace/tab,-whitespace/braces,-whitespace/labels,-build/header_guard,-readability/casting,-readability/todo,-build/include src/* serd/*', shell=True)

def amalgamate(ctx):
    shutil.copy('serd/serd.h', 'build/serd.h')
    amalgamation = open('build/serd.c', 'w')

    serd_internal_h = open('src/serd_internal.h')
    for l in serd_internal_h:
        if l == '#include "serd/serd.h"\n':
            amalgamation.write('#include "serd.h"\n')
        else:
            amalgamation.write(l)
    serd_internal_h.close()

    for f in lib_source:
        fd = open(f)
        amalgamation.write('\n/**\n   @file %s\n*/' % f)
        header = True
        for l in fd:
            if header:
                if l == '*/\n':
                    header = False
            else:
                if l != '#include "serd_internal.h"\n':
                    amalgamation.write(l)
        fd.close()
    amalgamation.close()

    for i in ['c', 'h']:
        Logs.info('Wrote build/serd.%s' % i)

def fix_docs(ctx):
    if ctx.cmd == 'build':
        autowaf.make_simple_dox(APPNAME)

def upload_docs(ctx):
    os.system('rsync -ravz --delete -e ssh build/doc/html/ drobilla@drobilla.net:~/drobilla.net/docs/serd/')
    for page in glob.glob('doc/*.[1-8]'):
        os.system('soelim %s | pre-grohtml troff -man -wall -Thtml | post-grohtml > build/%s.html' % (page, page))
        os.system('rsync -avz --delete -e ssh build/%s.html drobilla@drobilla.net:~/drobilla.net/man/' % page)

def file_equals(patha, pathb, subst_from='', subst_to=''):
    fa = open(patha, 'rU')
    fb = open(pathb, 'rU')
    for line in fa:
        if line.replace(subst_from, subst_to) != fb.readline().replace(subst_from, subst_to):
            return False
    fa.close()
    fb.close()
    return True

def earl_assertion(test, passed, asserter):
    import datetime

    asserter_str = ''
    if asserter is not None:
        asserter_str = '\n\tearl:assertedBy <%s> ;' % asserter

    passed_str = 'earl:failed'
    if passed:
        passed_str = 'earl:passed'

    return '''
[]
	a earl:Assertion ;%s
	earl:subject <http://drobilla.net/sw/serd> ;
	earl:test <%s> ;
	earl:result [
		a earl:TestResult ;
		earl:outcome %s ;
		dc:date "%s"^^xsd:dateTime
	] .
''' % (asserter_str,
       test,
       passed_str,
       datetime.datetime.now().replace(microsecond=0).isoformat())

def check_output(out_filename, check_filename, subst_from='', subst_to=''):
    if not os.access(out_filename, os.F_OK):
        Logs.pprint('RED', 'FAIL: output %s is missing' % out_filename)
    elif not file_equals(check_filename, out_filename, subst_from, subst_to):
        Logs.pprint('RED', 'FAIL: %s != %s' % (os.path.abspath(out_filename),
                                               check_filename))
    else:
        return True

    return False

def test_thru(ctx, base, path, check_filename, flags):
    in_filename = os.path.join(ctx.path.abspath(), path);
    out_filename = path + '.thru'

    command = ('%s %s -i turtle -o turtle -p foo "%s" "%s" | '
               '%s -i turtle -o ntriples -c foo - "%s" > %s') % (
        'serdi_static', flags.ljust(5),
        in_filename, base,
        'serdi_static', base, out_filename)

    if autowaf.run_test(ctx, APPNAME, command, 0, name=out_filename):
        autowaf.run_test(ctx, APPNAME,
                         [out_filename + '.check', check_output(out_filename, check_filename, '_:docid', '_:genid')],
                         1)
    else:
        Logs.pprint('RED', 'FAIL: error running %s' % command)

def test_manifest(ctx, srcdir, testdir, report, base_uri):
    import rdflib
    import urlparse

    rdf  = rdflib.Namespace('http://www.w3.org/1999/02/22-rdf-syntax-ns#')
    rdfs = rdflib.Namespace('http://www.w3.org/2000/01/rdf-schema#')
    mf   = rdflib.Namespace('http://www.w3.org/2001/sw/DataAccess/tests/test-manifest#')
    rdft = rdflib.Namespace('http://www.w3.org/ns/rdftest#')
    earl = rdflib.Namespace('http://www.w3.org/ns/earl#')

    model = rdflib.ConjunctiveGraph()
    model.parse(os.path.join(srcdir, 'tests', testdir, 'manifest.ttl'),

=== debian/changelog ===
serd (0.24.0~dfsg0-1) unstable; urgency=medium

  * New upstream version 0.24.0~dfsg0
  * Patches refreshed.
  * Bump Standards.
  * Fix VCS fields.
  * Fix some hardening.
  * Update symbols file.
  * Drop dbg package in favour of dbgsym.
  * Update copyright file.
  * Doxy patch dropped - not needed.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 22 Sep 2016 19:31:18 +0200

=== debian/control ===
Source: serd
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 debhelper (>= 9),
 pkg-config,
 python
Build-Depends-Indep:
 doxygen,
 graphviz
Standards-Version: 3.9.8
Homepage: http://drobilla.net/software/serd/
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/serd.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/serd.git

Package: libserd-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libserd-0-0 (= ${binary:Version}),
 ${misc:Depends}
Recommends:
 pkg-config
Suggests:
 libserd-doc
Description: lightweight RDF syntax library - development files
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the development files for Serd.

Package: libserd-0-0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 serdi
Description: lightweight RDF syntax library
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 Serd is not intended to be a swiss-army knife of RDF syntax, but rather
 is suited to resource limited applications, or situations where a simple
 reader/writer with minimal dependencies is ideal (e.g. in LV2 hosts or
 plugins).
 .
 Serd is:
  * small: Serd is implemented in under 2500 lines1 of standard C code.
  * portable and dependency-free: Serd uses only the C standard library,
    and has no external dependencies, making it a lightweight dependency
    in every sense.
  * fast and lightweight: Serd (and the included serdi tool) can be used
    to stream abbreviated Turtle (unlike many other tools which can not
    stream since they must first build an internal model to abbreviate).
    In other words, Serd can re-serialise an unbounded amount of Turtle
    using a fixed amount of memory, preserving the abbreviations in the
    input.
  * conformant and well-tested: Serd is written to the Turtle, NTriples
    and URI specifications, and includes a comprehensive test suite which
    includes all the normative examples from the Turtle specification, all
    the "normal" examples from the URI specification, and additional tests
    added specifically for Serd. The test suite has over 96% code coverage
    (by line), and runs with zero memory errors or leaks.

Package: serdi
Architecture: any
Section: text
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: lightweight RDF syntax library - serdi tool
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the utility 'serdi'.

Package: libserd-doc
Section: doc
Architecture: all
Enhances:
 libserd-dev
Depends:
 ${misc:Depends}
Description: lightweight RDF syntax library - documentation
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the developer's reference for serd.

=== debian/rules ===
#!/usr/bin/make -f

upstream_version ?= $(shell dpkg-parsechangelog | sed -rne 's/^Version: ([0-9.]+)(\+dfsg\d+)?.*$$/\1/p')
dfsg_version = $(upstream_version)~dfsg0
pkg = $(shell dpkg-parsechangelog | sed -ne 's/^Source: //p')

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LDFLAGS+=-Wl,--as-needed
WAF = ./waf

ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
CONFIGURE_EXTRA_FLAGS += --docs
endif

%:
	dh $@ --parallel

override_dh_auto_configure:
	$(WAF) configure \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--strict \
		$(CONFIGURE_EXTRA_FLAGS)

override_dh_auto_build:
	$(WAF)

override_dh_auto_clean:
	$(WAF) clean || true
	find -name "*.pyc" -delete
	rm -rf build .waf*
	rm -rf .lock-*_build
	dh_auto_clean

override_dh_auto_install:
	$(WAF) install --destdir=$(CURDIR)/debian/tmp

override_dh_installchangelogs:
	dh_installchangelogs NEWS

# get-orig-source to drop waf
get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=.
	tar -xf $(pkg)_$(upstream_version).orig.tar.bz2
	mv $(pkg)-$(upstream_version) $(pkg)-$(dfsg_version)
	cd $(pkg)-$(dfsg_version) ; python waf --help > /dev/null
	mv $(pkg)-$(dfsg_version)/.waf-*/* $(pkg)-$(dfsg_version)
	sed -i '/^#==>$$/,$$d' $(pkg)-$(dfsg_version)/waf
	rmdir $(pkg)-$(dfsg_version)/.waf-*
	find $(pkg)-$(dfsg_version)/ -name '*.pyc' -delete
	tar cf $(pkg)_$(dfsg_version).orig.tar $(pkg)-$(dfsg_version)
	xz -9fz $(pkg)_$(dfsg_version).orig.tar
	rm -rf $(pkg)-$(dfsg_version)
	mv $(pkg)_$(dfsg_version).orig.tar.xz ../$(pkg)_$(dfsg_version).orig.tar.xz
	mv $(pkg)_$(upstream_version).orig.tar.bz2 ../$(pkg)_$(upstream_version).orig.tar.bz2

## serd 0.26.0~dfsg0

=== wscript ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # major increment <=> incompatible changes
 # minor increment <=> compatible changes (additions)
 # micro increment <=> no interface changes
-SERD_VERSION       = '0.24.0'
+SERD_VERSION       = '0.26.0'
 SERD_MAJOR_VERSION = '0'
 
 # Mandatory waf variables
@@ -297,15 +297,15 @@
 
     return False
 
-def test_thru(ctx, base, path, check_filename, flags):
+def test_thru(ctx, base, path, check_filename, flags, isyntax, osyntax):
     in_filename = os.path.join(ctx.path.abspath(), path);
     out_filename = path + '.thru'
 
-    command = ('%s %s -i turtle -o turtle -p foo "%s" "%s" | '
-               '%s -i turtle -o ntriples -c foo - "%s" > %s') % (
-        'serdi_static', flags.ljust(5),
-        in_filename, base,
-        'serdi_static', base, out_filename)
+    command = ('%s %s -i %s -o %s -p foo "%s" "%s" | '
+               '%s -i %s -o %s -c foo - "%s" > %s') % (
+                   'serdi_static', flags.ljust(5),
+                   isyntax, isyntax, in_filename, base,
+                   'serdi_static', isyntax, osyntax, base, out_filename)
 
     if autowaf.run_test(ctx, APPNAME, command, 0, name=out_filename):
         autowaf.run_test(ctx, APPNAME,
@@ -314,15 +314,14 @@
     else:
         Logs.pprint('RED', 'FAIL: error running %s' % command)
 
-def test_manifest(ctx, srcdir, testdir, report, base_uri):
+def test_manifest(ctx, srcdir, testdir, report, base_uri, isyntax, osyntax, test_runs):
     import rdflib
     import urlparse
 
     rdf  = rdflib.Namespace('http://www.w3.org/1999/02/22-rdf-syntax-ns#')
     rdfs = rdflib.Namespace('http://www.w3.org/2000/01/rdf-schema#')
     mf   = rdflib.Namespace('http://www.w3.org/2001/sw/DataAccess/tests/test-manifest#')
-    rdft = rdflib.Namespace('http://www.w3.org/ns/rdftest#')
     earl = rdflib.Namespace('http://www.w3.org/ns/earl#')
 
     model = rdflib.ConjunctiveGraph()
-    model.parse(os.path.join(srcdir, 'tests', testdir, 'manifest.ttl'),
+    try:

=== debian/changelog ===
serd (0.26.0~dfsg0-1) unstable; urgency=medium

  * New upstream version 0.26.0~dfsg0
  * Set dh/compat 10.
  * Sign tags.
  * Update copyright file.
  * Avoid useless linking.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 15 Jan 2017 21:10:18 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 10),
  pkg-config,
  python
 Build-Depends-Indep:

## serd 0.28.0~dfsg0

=== wscript ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # major increment <=> incompatible changes
 # minor increment <=> compatible changes (additions)
 # micro increment <=> no interface changes
-SERD_VERSION       = '0.26.0'
+SERD_VERSION       = '0.28.0'
 SERD_MAJOR_VERSION = '0'
 
 # Mandatory waf variables
@@ -78,6 +78,11 @@
                    defines       = ['_POSIX_C_SOURCE=200809L'],
                    mandatory     = False)
 
+    conf.check(fragment      = 'int main() { return __builtin_clz(1); }',
+               function_name = '__builtin_clz',
+               define_name   = 'HAVE_BUILTIN_CLZ',
+               mandatory     = False)
+
     autowaf.define(conf, 'SERD_VERSION', SERD_VERSION)
     autowaf.set_lib_env(conf, 'serd', SERD_VERSION)
     conf.write_config_header('serd_config.h', remove=False)
@@ -87,6 +92,7 @@
     print('')
 
 lib_source = [
+    'src/byte_source.c',
     'src/env.c',
     'src/node.c',
     'src/reader.c',
@@ -210,6 +216,7 @@
 
 def lint(ctx):
     subprocess.call('cpplint.py --filter=+whitespace/comments,-whitespace/tab,-whitespace/braces,-whitespace/labels,-build/header_guard,-readability/casting,-readability/todo,-build/include src/* serd/*', shell=True)
+    subprocess.call('clang-tidy -checks="*,-misc-unused-parameters,-readability-else-after-return,-llvm-header-guard,-google-readability-todo,-clang-analyzer-alpha.*" -extra-arg="-std=c99" -extra-arg="-I." -extra-arg="-Ibuild" ./serd/*.h ./src/*.c ./src/*.h', shell=True)
 
 def amalgamate(ctx):
     shutil.copy('serd/serd.h', 'build/serd.h')
@@ -314,14 +321,3 @@
     else:
         Logs.pprint('RED', 'FAIL: error running %s' % command)
 
-def test_manifest(ctx, srcdir, testdir, report, base_uri, isyntax, osyntax, test_runs):
-    import rdflib
-    import urlparse
-
-    rdf  = rdflib.Namespace('http://www.w3.org/1999/02/22-rdf-syntax-ns#')
-    rdfs = rdflib.Namespace('http://www.w3.org/2000/01/rdf-schema#')
-    mf   = rdflib.Namespace('http://www.w3.org/2001/sw/DataAccess/tests/test-manifest#')
-    earl = rdflib.Namespace('http://www.w3.org/ns/earl#')
-
-    model = rdflib.ConjunctiveGraph()
-    try:

=== debian/changelog ===
serd (0.28.0~dfsg0-1) unstable; urgency=medium

  * New upstream version 0.28.0~dfsg0
  * Patch refreshed.
  * Bump Standards.
  * Fix dh version.
  * Update symbols file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 24 Jul 2017 08:03:53 +0200

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,13 @@
  Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 10~),
  pkg-config,
  python
 Build-Depends-Indep:
  doxygen,
  graphviz
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://drobilla.net/software/serd/
 Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/serd.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/serd.git

=== debian/rules ===
--- 
+++ 
@@ -6,8 +6,12 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+
+export LINKFLAGS += $(LDFLAGS)
+
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
-LDFLAGS+=-Wl,--as-needed
+
 WAF = ./waf
 
 ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
@@ -15,7 +19,7 @@
 endif
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
 	$(WAF) configure \

=== debian/watch ===
version=3
opts="uversionmangle=s/-/./,dversionmangle=s/~dfsg.*//" \
http://download.drobilla.net/serd-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## serd 0.30.2

=== debian/changelog ===
serd (0.30.2-1) unstable; urgency=medium

  * Team upload

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ Olivier Humbert ]
  * d/control: http -> https
  * d/copyright: http -> https

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #913422)
    + Build-Depends request build architecture python.
    + Tell waf what we build for.

  [ Sebastian Ramacher ]
  * New upstream release
  * debian/rules:
    - Remove get-orig-source
    - Use dpkg's architecture.mk
  * debian/: Use python3 to run waf (Closes: #943204)
  * debian/libserd0-0.symbols: Add new symbol
  * debian/patches: Refresh patches
  * debian/control:
    - Set RRR: no
    - Bump debhelper compat to 12
    - Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 08 Dec 2019 21:11:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,22 @@
 Source: serd
 Section: libs
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
- debhelper (>= 10~),
+ debhelper-compat (= 12),
  pkg-config,
- python
+ python3:any
 Build-Depends-Indep:
  doxygen,
  graphviz
-Standards-Version: 4.0.0
-Homepage: http://drobilla.net/software/serd/
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/serd.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/serd.git
+Standards-Version: 4.4.1
+Homepage: https://drobilla.net/software/serd/
+Vcs-Git: https://salsa.debian.org/multimedia-team/serd.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/serd
+Rules-Requires-Root: no
 
 Package: libserd-dev
 Section: libdevel

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export LINKFLAGS += $(LDFLAGS)

include /usr/share/dpkg/architecture.mk
-include /usr/share/dpkg/buildtools.mk
PKG_CONFIG ?= pkg-config

WAF = python3 ./waf

ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
CONFIGURE_EXTRA_FLAGS += --docs
endif

%:
	dh $@

override_dh_auto_configure:
	CC="$(CC)" PKGCONFIG="$(PKG_CONFIG)" $(WAF) configure \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--strict \
		$(CONFIGURE_EXTRA_FLAGS)

override_dh_auto_build:
	$(WAF)

override_dh_auto_clean:
	$(WAF) clean || true
	find -name "*.pyc" -delete
	rm -rf build .waf*
	rm -rf .lock-*_build
	dh_auto_clean

override_dh_auto_install:
	$(WAF) install --destdir=$(CURDIR)/debian/tmp

override_dh_installchangelogs:
	dh_installchangelogs NEWS

## serd 0.30.4

=== wscript ===
#!/usr/bin/env python

import glob
import io
import os
import sys

from waflib import Logs, Options
from waflib.extras import autowaf

# Library and package version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
SERD_VERSION       = '0.30.4'
SERD_MAJOR_VERSION = '0'

# Mandatory waf variables
APPNAME = 'serd'        # Package name for waf dist
VERSION = SERD_VERSION  # Package version for waf dist
top     = '.'           # Source directory
out     = 'build'       # Build directory

# Release variables
uri          = 'http://drobilla.net/sw/serd'
dist_pattern = 'http://download.drobilla.net/serd-%d.%d.%d.tar.bz2'
post_tags    = ['Hacking', 'RDF', 'Serd']

def options(ctx):
    ctx.load('compiler_c')
    ctx.add_flags(
        ctx.configuration_options(),
        {'no-utils':     'do not build command line utilities',
         'stack-check':  'include runtime stack sanity checks',
         'static':       'build static library',
         'no-shared':    'do not build shared library',
         'static-progs': 'build programs as static binaries',
         'largefile':    'build with large file support on 32-bit systems',
         'no-posix':     'do not use POSIX functions, even if present'})

def configure(conf):
    conf.load('compiler_c', cache=True)
    conf.load('autowaf', cache=True)
    autowaf.set_c_lang(conf, 'c99')

    conf.env.update({
        'BUILD_UTILS':  not Options.options.no_utils,
        'BUILD_SHARED': not Options.options.no_shared,
        'STATIC_PROGS': Options.options.static_progs,
        'BUILD_STATIC': Options.options.static or Options.options.static_progs})

    if not conf.env.BUILD_SHARED and not conf.env.BUILD_STATIC:
        conf.fatal('Neither a shared nor a static build requested')

    if Options.options.stack_check:
        conf.define('SERD_STACK_CHECK', SERD_VERSION)

    if Options.options.largefile:
        conf.env.append_unique('DEFINES', ['_FILE_OFFSET_BITS=64'])

    if not Options.options.no_posix:
        for name, header in {'posix_memalign': 'stdlib.h',
                             'posix_fadvise':  'fcntl.h',
                             'fileno':         'stdio.h'}.items():
            conf.check_function('c', name,
                                header_name = header,
                                define_name = 'HAVE_' + name.upper(),
                                defines     = ['_POSIX_C_SOURCE=200809L'],
                                mandatory   = False)

    autowaf.set_lib_env(conf, 'serd', SERD_VERSION)
    conf.write_config_header('serd_config.h', remove=False)

    autowaf.display_summary(
        conf,
        {'Build static library': bool(conf.env['BUILD_STATIC']),
         'Build shared library': bool(conf.env['BUILD_SHARED']),
         'Build utilities':      bool(conf.env['BUILD_UTILS']),
         'Build unit tests':     bool(conf.env['BUILD_TESTS'])})

lib_headers = ['src/reader.h']

lib_source = ['src/byte_source.c',
              'src/env.c',
              'src/n3.c',
              'src/node.c',
              'src/reader.c',
              'src/string.c',
              'src/uri.c',
              'src/writer.c']

def build(bld):
    # C Headers
    includedir = '${INCLUDEDIR}/serd-%s/serd' % SERD_MAJOR_VERSION
    bld.install_files(includedir, bld.path.ant_glob('serd/*.h'))

    # Pkgconfig file
    autowaf.build_pc(bld, 'SERD', SERD_VERSION, SERD_MAJOR_VERSION, [],
                     {'SERD_MAJOR_VERSION' : SERD_MAJOR_VERSION})

    defines = []
    lib_args = {'export_includes': ['.'],
                'includes':        ['.', './src'],
                'cflags':          ['-fvisibility=hidden'],
                'lib':             ['m'],
                'vnum':            SERD_VERSION,
                'install_path':    '${LIBDIR}'}
    if bld.env.MSVC_COMPILER:
        lib_args['cflags'] = []
        lib_args['lib']    = []
        defines            = []

    # Shared Library
    if bld.env.BUILD_SHARED:
        bld(features        = 'c cshlib',
            source          = lib_source,
            name            = 'libserd',
            target          = 'serd-%s' % SERD_MAJOR_VERSION,
            defines         = defines + ['SERD_SHARED', 'SERD_INTERNAL'],
            **lib_args)

    # Static library
    if bld.env.BUILD_STATIC:
        bld(features        = 'c cstlib',
            source          = lib_source,
            name            = 'libserd_static',
            target          = 'serd-%s' % SERD_MAJOR_VERSION,
            defines         = defines + ['SERD_INTERNAL'],
            **lib_args)

    if bld.env.BUILD_TESTS:
        test_args = {'includes':     ['.', './src'],
                     'cflags':       [''] if bld.env.NO_COVERAGE else ['--coverage'],
                     'linkflags':    [''] if bld.env.NO_COVERAGE else ['--coverage'],
                     'lib':          lib_args['lib'],
                     'install_path': ''}

        # Profiled static library for test coverage
        bld(features     = 'c cstlib',
            source       = lib_source,
            name         = 'libserd_profiled',
            target       = 'serd_profiled',
            defines      = defines + ['SERD_INTERNAL'],
            **test_args)

        # Test programs
        for prog in [('serdi_static', 'src/serdi.c'),
                     ('serd_test', 'tests/serd_test.c')]:
            bld(features     = 'c cprogram',
                source       = prog[1],
                use          = 'libserd_profiled',
                target       = prog[0],
                defines      = defines,
                **test_args)

    # Utilities
    if bld.env.BUILD_UTILS:
        obj = bld(features     = 'c cprogram',
                  source       = 'src/serdi.c',
                  target       = 'serdi',
                  includes     = ['.', './src'],
                  use          = 'libserd',
                  lib          = lib_args['lib'],
                  install_path = '${BINDIR}')
        if not bld.env.BUILD_SHARED or bld.env.STATIC_PROGS:
            obj.use = 'libserd_static'
        if bld.env.STATIC_PROGS:
            obj.env.SHLIB_MARKER = obj.env.STLIB_MARKER
            obj.linkflags        = ['-static']

    # Documentation
    if bld.env.DOCS:
        autowaf.build_dox(bld, 'SERD', SERD_VERSION, top, out)
        bld(features='subst',
            source='doc/index.html.in',
            target='doc/index.html',
            install_path='',
            name='index',
            SERD_VERSION=SERD_VERSION)

    # Man page
    bld.install_files('${MANDIR}/man1', 'doc/serdi.1')

    bld.add_post_fun(autowaf.run_ldconfig)

def lint(ctx):
    "checks code for style issues"
    import subprocess
    cmd = ("clang-tidy -p=. -header-filter=.* -checks=\"*," +
           "-bugprone-suspicious-string-compare," +
           "-clang-analyzer-alpha.*," +
           "-google-readability-todo," +
           "-hicpp-signed-bitwise," +
           "-llvm-header-guard," +
           "-misc-unused-parameters," +
           "-readability-else-after-return\" " +
           "../src/*.c")
    subprocess.call(cmd, cwd='build', shell=True)

def amalgamate(ctx):
    "builds single-file amalgamated source"
    import shutil
    shutil.copy('serd/serd.h', 'build/serd.h')
    with open('build/serd.c', 'w') as amalgamation:
        with open('src/serd_internal.h') as serd_internal_h:
            for l in serd_internal_h:
                amalgamation.write(l.replace('serd/serd.h', 'serd.h'))

        for f in lib_headers + lib_source:
            with open(f) as fd:
                amalgamation.write('\n/**\n   @file %s\n*/' % f)
                header = True
                for l in fd:
                    if header:
                        if l == '*/\n':
                            header = False
                    else:
                        if (not l.startswith('#include "') and
                            l != '#include "serd.h"\n'):
                            amalgamation.write(l)

    for i in ['c', 'h']:
        Logs.info('Wrote build/serd.%s' % i)

def earl_assertion(test, passed, asserter):
    import datetime

    asserter_str = ''
    if asserter is not None:
        asserter_str = '\n\tearl:assertedBy <%s> ;' % asserter

    return '''
[]
	a earl:Assertion ;%s
	earl:subject <http://drobilla.net/sw/serd> ;
	earl:test <%s> ;
	earl:result [
		a earl:TestResult ;
		earl:outcome %s ;
		dc:date "%s"^^xsd:dateTime
	] .
''' % (asserter_str,
       test,
       'earl:passed' if passed else 'earl:failed',
       datetime.datetime.now().replace(microsecond=0).isoformat())

serdi = './serdi_static'

def test_thru(check, base, path, check_path, flags, isyntax, osyntax, opts=[]):
    out_path = path + '.pass'
    out_cmd = [serdi] + opts + [f for sublist in flags for f in sublist] + [
        '-i', isyntax,
        '-o', isyntax,
        '-p', 'foo',
        check.tst.src_path(path), base]

    thru_path = path + '.thru'
    thru_cmd = [serdi] + opts + [
        '-i', isyntax,
        '-o', osyntax,
        '-c', 'foo',
        out_path,
        base]

    return (check(out_cmd, stdout=out_path, verbosity=0, name=out_path) and
            check(thru_cmd, stdout=thru_path, verbosity=0, name=thru_path) and
            check.file_equals(check_path, thru_path, verbosity=0))

def file_uri_to_path(uri):
    try:
        from urlparse import urlparse # Python 2
    except:
        from urllib.parse import urlparse # Python 3

    path  = urlparse(uri).path
    drive = os.path.splitdrive(path[1:])[0]
    return path if not drive else path[1:]

def _test_output_syntax(test_class):
    if 'NTriples' in test_class or 'Turtle' in test_class:
        return 'NTriples'
    elif 'NQuads' in test_class or 'Trig' in test_class:
        return 'NQuads'
    raise Exception('Unknown test class <%s>' % test_class)

def _load_rdf(filename):
    "Load an RDF file into python dictionaries via serdi.  Only supports URIs."
    import subprocess
    import re

    rdf_type = 'http://www.w3.org/1999/02/22-rdf-syntax-ns#type'
    model = {}
    instances = {}

    cmd = ['./serdi_static', filename]
    if Options.options.test_wrapper:
        import shlex
        cmd = shlex.split(Options.options.test_wrapper) + cmd

    proc = subprocess.Popen(cmd, stdout=subprocess.PIPE)
    for line in proc.communicate()[0].splitlines():
        matches = re.match('<([^ ]*)> <([^ ]*)> <([^ ]*)> \.', line.decode('utf-8'))
        if matches:
            s, p, o = (matches.group(1), matches.group(2), matches.group(3))
            if s not in model:
                model[s] = {p: [o]}
            elif p not in model[s]:
                model[s][p] = [o]
            else:
                model[s][p].append(o)

            if p == rdf_type:
                if o not in instances:
                    instances[o] = set([s])
                else:
                    instances[o].update([s])

    return model, instances

def test_suite(ctx, base_uri, testdir, report, isyntax, options=[]):
    import itertools

    srcdir = ctx.path.abspath()

    mf = 'http://www.w3.org/2001/sw/DataAccess/tests/test-manifest#'
    manifest_path = os.path.join(srcdir, 'tests', testdir, 'manifest.ttl')
    model, instances = _load_rdf(manifest_path)

    asserter = ''
    if os.getenv('USER') == 'drobilla':
        asserter = 'http://drobilla.net/drobilla#me'

    def run_tests(test_class, tests, expected_return):
        thru_flags   = [['-e'], ['-f'], ['-b'], ['-r', 'http://example.org/']]
        thru_options = []
        for n in range(len(thru_flags) + 1):
            thru_options += list(itertools.combinations(thru_flags, n))
        thru_options_iter = itertools.cycle(thru_options)

        osyntax = _test_output_syntax(test_class)
        tests_name = '%s.%s' % (testdir, test_class[test_class.find('#') + 1:])
        with ctx.group(tests_name) as check:

=== debian/changelog ===
serd (0.30.4-1) unstable; urgency=medium

  * New upstream version 0.30.4
  * Bump S-V to 4.5.0
  * Bump dh-compat to 13
  * Add me as uploader
  * Fix bad-whatis-entry in serd.3
  * Mark libserd-doc as Multi-Arch: foreign
  * Make libserd-doc depend on libjs-jquery
  * Link the jquery.js from libjs-jquery
  * Add libserd-dev as B-D to the symbols file
  * Update d/copyright year
  * d/watch: Use https protocol
  * Remove obsolete DEB_LDFLAGS_MAINT_APPEND export
  * Add d/upstream/signing-key.asc
  * Add d/upstream/metadata

 -- Dennis Braun <d_braun@kabelmail.de>  Sat, 13 Jun 2020 02:29:30 +0200

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,6 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 export LINKFLAGS += $(LDFLAGS)
 
 include /usr/share/dpkg/architecture.mk
